#include 'Average.ch'
#include 'TopConn.ch'

/*
Funcao      : Pendencias
Objetivos   : Abre a tela contendo as pendencias do processo selecionado
Parmetros  : cFase : 1 = Tela de DI, 2 = Log - cCodPen : vir em branco na tela de DI, presente somente na rotina de log
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 11/08/2011
*/
*-------------------------------------------------*
User Function Pendencias(cFase,cCodPen)
*-------------------------------------------------*
Local   bOk        := {|| lOk := .T., oDlg:End()}
Local   bCancel    := {|| lOk := .T., oDlg:End()}
Local   oEnc
Local   i          := 1
Local   aTB_Campos := {} 
Default cCodPen    := maiorCod()
Private lOk        := .F. 
Private aTela      := {}
Private aGets      := {} 
Private cMarca     := ""
Private lInverte   := .F.
Private cCod       := cCodPen

//verifica se existe alguma pendncia disponvel para o processo
//se no existir j exibe mensagem e sai da rotina 
ZR4->(dbSetOrder(1))
If !(ZR4->(dbSeek(xFilial("ZR4")+cCod)))
   MsgStop("No existem pendncias"+ENTER+;
           "para o processo selecionado.")
   Return
EndIf  

//verifica se existem pendencias para o processo corrente quando a rotina  chamada da tela de DI
If cFase == "1"
   If !SW6->W6_ZPENDE
      MsgStop("No existem pendncias"+ENTER+;
              "para o processo selecionado.")
      Return      
   EndIf
EndIf


//tenta criar work, caso no consiga retorna mensagem
If !CriaWork()
   MsgStop("Impossvel criar work."+ENTER+;
           "Entre em contato com a Average.")
   Return
Else
   //preenche arquivo de trabalho com os dados de log
   preencheWk()
   aAdd(aTB_Campos,{"ZR5_PENDEN","",AVSX3("ZR5_PENDEN",5),AVSX3("ZR5_PENDEN",6) })
EndIf

//Cria variveis de memria - utilizado pelo msmget (no utilizar se for s msselect)
For i := 1 To ZR4->(FCount())
      M->&(ZR4->(FieldName(i))) := ZR4->(FieldGet(i))
Next i   


//abertura da tela de pendncias (capa/detalhe)
Define MsDialog oDlg Title "Pendncias" From DLG_LIN_INI, DLG_COL_INI To DLG_LIN_FIM, DLG_COL_FIM Of oMainWnd Pixel
   *
   //Capa das Pendncias  - no utilizar no caso de ser somente a listagem
   aPos := PosDlgUp(oDlg)
   aPos[3] -= 70
   oEnc := MsMget():New("ZR4",nil,VISUALIZAR,,,,,aPos,,,,,,,,,,,,,,,,,)  
   oDlg:lMaximized:=.T.    
   *
   //Detalhe das Pendncias
   aPos := PosDlgDown(oDlg) 
   aPos[1] -= 70
   oMSPend := WKPEND->(MsSelect():New("WKPEND",,,aTB_campos,@lInverte,@cMarca,aPos,,,oDlg))
   *
Activate MsDialog oDlg On Init (EnchoiceBar(oDlg,bOk,bCancel,,),oEnc:oBox:Align := CONTROL_ALIGN_TOP,)

If Select("WKPEND") > 0
   WKPEND->(dbCloseArea())
EndIf 


Return

/*
Funcao      : CriaWork
Objetivos   : Cria arquivo de trabalho onde estaro os dados do log que esto sendo observados
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 11/08/2011
*/
*-------------------------------------------------*
Static Function CriaWork()
*-------------------------------------------------*   
Local aSemSx3 := {}

//cria work do msselect            
aHeader := {} 
//cria um array com a quantidade de campos da tabela ZR1
aCampos := Array(ZR1->(fCount()))
//cria arquivo temporrio com a estrutura da tabela ZR5+aSemSx3 caso exista algum campo a mais
cFile := E_CriaTrab("ZR5",aSemSx3,"WKPEND")   
//verifica se conseguiu criar o arquivo de trabalho
If !Used()
   Return .F.
EndIf 
//adiciona ndice ao arquivo criado
IndRegua("WKPEND",cFile+OrdBagExt(),"ZR5_PROCES")


Return .T.  


/*
Funcao      : preencheWk
Objetivos   : Preenche a Work com as pendncias relativas ao processo corrente
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 12/08/2011
*/
*-------------------------------------------------*
Static Function preencheWk()
*-------------------------------------------------*
Local cQuery := ""
//busca os dados de log
cQuery += "SELECT ZR5_PENDEN FROM "
cQuery += RetSqlName("ZR5")+" ZR5 "
cQuery += "WHERE " + RetSqlCond("ZR5")
cQuery += " AND ZR5_COD='"+cCod+"'"
//executa a query
GerTCQuery(cQuery,"Q_QRY",.T.)

//verifica se teve algum retorno
If Q_QRY->(EOF()) .AND. Q_QRY->(BOF())
   Return .F.
EndIf    

//limpa o arquivo de trabalho para garantir que no vai trazer "sujeira"
WKPEND->(__dbZap())
//Copia dados resultantes da query para a work do msselect
While Q_QRY->(!EOF())

   WKPEND->(dbAppend())
   //copia todos os campos em comum do arquivo de trabalho Q_QRY para o arquivo WKPEND
   AvReplace("Q_QRY","WKPEND")
   Q_QRY->(dbSkip())
   
EndDo
WKPEND->(dbGoTop())
//
Return .T.

/*
Funcao      : maiorCod
Objetivos   : Retorna o maior cdigo de log do processo corrente, com a finalidade de posicionar as ultimas
              pendncias, essa rotina ser executada somente quando estiver na tela de DI,
              na tela de log j recebera como parmetro o cdigo corrente.
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 12/08/2011
*/
*-------------------------------------------------*
Static Function maiorCod()
*-------------------------------------------------*
Local cMaiorCod := ""
Local cQry := ""
//monta a query
cQry += "SELECT MAX(ZR4_COD) AS MAX FROM "
cQry += RetSqlName("ZR4") + " ZR4 "
cQry += "WHERE " + RetSqlCond("ZR4") + " "
cQry += "AND ZR4_PROCES='"+SW6->W6_HAWB+"'"
//executa a query
If GerTCQuery(cQry,"Q_QRY",.T.)
   //salva o codigo a ser retornado
   cMaiorCod := Q_QRY->MAX
EndIf
//
Return cMaiorCod



/*
Funcao      : GerTCQuery
Objetivos   : Executa a query de busca salvando um log da query na system
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 12/08/2011
*/
*-------------------------------------------------*
Static Function GerTCQuery(cQuery,cAlias,lEraseLog)
*-------------------------------------------------*
Local nCod

Default lEraseLog := .T.

If lEraseLog
   nCod := FCreate("cQuery.TXT")
Else
   nCod := FOpen("cQuery.TXT",2)
EndIf

If nCod # -1
   FWRITE(nCod,cQuery)
   Fclose(nCod)
EndIf

cQuery := ChangeQuery(cQuery)

If Select(cAlias) # 0
   (cAlias)->(dbCloseArea())
EndIf

TcQuery cQuery ALIAS (cAlias) NEW

If !USED()
   Return .F.
EndIf


Return .T.   